From 4433330e24e7fd16a3ed149f89acd614f29673aa Mon Sep 17 00:00:00 2001
From: Alexey Min <alexey.min@gmail.com>
Date: Mon, 29 Jun 2020 03:22:42 +0300
Subject: [PATCH 22/59] AlpineApkAuthHelper: add method to write repositories
 config

---
 .../AlpineApkBackend/AlpineApkAuthHelper.cpp  | 21 +++++++++++++++++++
 .../AlpineApkBackend/AlpineApkAuthHelper.h    |  1 +
 .../org.kde.discover.alpineapkbackend.actions |  6 ++++++
 3 files changed, 28 insertions(+)

diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
index a3236011f..81c18255c 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
@@ -265,4 +265,25 @@ ActionReply AlpineApkAuthHelper::upgrade(const QVariantMap &args)
     return m_actionReply;
 }
 
+ActionReply AlpineApkAuthHelper::repoconfig(const QVariantMap &args)
+{
+    m_actionReply = ActionReply::HelperErrorReply();
+    HelperSupport::progressStep(10);
+
+    if (args.contains(QLatin1String("repoList"))) {
+        const QVariant v = args.value(QLatin1String("repoList"));
+        const QVector<QtApk::Repository> repoVec = v.value<QVector<QtApk::Repository>>();
+        if (QtApk::Database::saveRepositories(repoVec)) {
+            m_actionReply = ActionReply::SuccessReply(); // OK
+        } else {
+            m_actionReply.setErrorDescription(QStringLiteral("Failed to write repositories config!"));
+        }
+    } else {
+        m_actionReply.setErrorDescription(QStringLiteral("repoList parameter is missing in request!"));
+    }
+
+    HelperSupport::progressStep(100);
+    return m_actionReply;
+}
+
 KAUTH_HELPER_MAIN("org.kde.discover.alpineapkbackend", AlpineApkAuthHelper)
diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h
index a670a2aa1..acce56488 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h
@@ -38,6 +38,7 @@ public Q_SLOTS:
     ActionReply add(const QVariantMap &args);
     ActionReply del(const QVariantMap &args);
     ActionReply upgrade(const QVariantMap &args);
+    ActionReply repoconfig(const QVariantMap &args);
 
 protected:
     bool openDatabase(const QVariantMap &args, bool readwrite = true);
diff --git a/libdiscover/backends/AlpineApkBackend/org.kde.discover.alpineapkbackend.actions b/libdiscover/backends/AlpineApkBackend/org.kde.discover.alpineapkbackend.actions
index 0755c4157..f1bffe654 100644
--- a/libdiscover/backends/AlpineApkBackend/org.kde.discover.alpineapkbackend.actions
+++ b/libdiscover/backends/AlpineApkBackend/org.kde.discover.alpineapkbackend.actions
@@ -21,3 +21,9 @@ Name=Remove package
 Description=Uninstall one package
 Policy=auth_admin
 Persistence=session
+
+[org.kde.discover.alpineapkbackend.repoconfig]
+Name=Remove package
+Description=Configure repositories URLs
+Policy=auth_admin
+Persistence=session
-- 
GitLab


